diff --git a/librsvg-features.h.in b/librsvg-features.h.in
index 32c87d7..8950ed6 100644
--- a/librsvg-features.h.in
+++ b/librsvg-features.h.in
@@ -1,5 +1,9 @@
+#if !defined (__RSVG_RSVG_H_INSIDE__) && !defined (RSVG_COMPILATION)
+#warning "Including <librsvg/librsvg-features.h> directly is deprecated."
+#endif
+
 #ifndef LIBRSVG_FEATURES_H
-#define LIBRSVG_FEATURES_H 1
+#define LIBRSVG_FEATURES_H
 
 #define LIBRSVG_MAJOR_VERSION (@LIBRSVG_MAJOR_VERSION@)
 #define LIBRSVG_MINOR_VERSION (@LIBRSVG_MINOR_VERSION@)
@@ -11,15 +15,36 @@
    (LIBRSVG_MAJOR_VERSION == (major) && LIBRSVG_MINOR_VERSION > (minor)) || \
    (LIBRSVG_MAJOR_VERSION == (major) && LIBRSVG_MINOR_VERSION == (minor) && LIBRSVG_MICRO_VERSION >= (micro)))
 
-#define LIBRSVG_HAVE_SVGZ  (@LIBRSVG_HAVE_SVGZ@)
-#define LIBRSVG_HAVE_CSS   (@LIBRSVG_HAVE_CSS@)
+#ifndef __GI_SCANNER__
+#define LIBRSVG_HAVE_SVGZ  (TRUE)
+#define LIBRSVG_HAVE_CSS   (TRUE)
 
 #define LIBRSVG_CHECK_FEATURE(FEATURE) (defined(LIBRSVG_HAVE_##FEATURE) && LIBRSVG_HAVE_##FEATURE)
+#endif
 
-extern const unsigned int librsvg_major_version, librsvg_minor_version, librsvg_micro_version;
-extern const char *librsvg_version;
+/*
+ * On Windows builds, we need to decorate variables that are exposed in the public API
+ * so that they can be properly exported and linked to, for DLL builds
+ */
+#ifndef RSVG_VAR
+# ifdef G_PLATFORM_WIN32
+#  ifndef RSVG_STATIC
+#   ifdef RSVG_COMPILATION
+#    define RSVG_VAR extern __declspec (dllexport)
+#   else /* RSVG_COMPILATION */
+#    define RSVG_VAR extern __declspec (dllimport)
+#   endif /* !RSVG_COMPILATION */
+#  else /* !RSVG_STATIC */
+#   define RSVG_VAR extern
+#  endif /* RSVG_STATIC */
+# else /* G_PLATFORM_WIN32 */
+#  define RSVG_VAR extern
+# endif /* !G_PLATFORM_WIN32 */
+#endif
 
-void librsvg_preinit(void *app, void *modinfo);
-void librsvg_postinit(void *app, void *modinfo);
+RSVG_VAR const guint librsvg_major_version;
+RSVG_VAR const guint librsvg_minor_version;
+RSVG_VAR const guint librsvg_micro_version;
+RSVG_VAR const char librsvg_version[];
 
 #endif
diff --git a/rsvg-base-file-util.c b/rsvg-base-file-util.c
index cda64af..bf89a14 100644
--- a/rsvg-base-file-util.c
+++ b/rsvg-base-file-util.c
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-file-util.c: SAX-based renderer for SVG files into a GdkPixbuf.
 
@@ -25,32 +26,32 @@
 
 #include "config.h"
 #include "rsvg.h"
+#include "rsvg-io.h"
 #include "rsvg-private.h"
 
 static gboolean
 rsvg_handle_fill_with_data (RsvgHandle * handle,
-                            const guint8 * data, gsize data_len, GError ** error)
+                            const char * data, gsize data_len, GError ** error)
 {
+    gboolean rv;
+
     rsvg_return_val_if_fail (data != NULL, FALSE, error);
     rsvg_return_val_if_fail (data_len != 0, FALSE, error);
 
-    if (!rsvg_handle_write (handle, data, data_len, error))
-        return FALSE;
-    if (!rsvg_handle_close (handle, error))
-        return FALSE;
+    rv = rsvg_handle_write (handle, (guchar *) data, data_len, error);
 
-    return TRUE;
+    return rsvg_handle_close (handle, rv ? error : NULL) && rv;
 }
 
 /**
  * rsvg_handle_new_from_data:
- * @data: The SVG data
- * @data_len: The length of #data, in bytes
+ * @data: (array length=data_len): The SVG data
+ * @data_len: The length of @data, in bytes
  * @error: return location for errors
  *
- * Loads the SVG specified by #data.
+ * Loads the SVG specified by @data.
  *
- * Returns: A RsvgHandle or %NULL if an error occurs.
+ * Returns: A #RsvgHandle or %NULL if an error occurs.
  * Since: 2.14
  */
 RsvgHandle *
@@ -61,8 +62,8 @@ rsvg_handle_new_from_data (const guint8 * data, gsize data_len, GError ** error)
     handle = rsvg_handle_new ();
 
     if (handle) {
-        if (!rsvg_handle_fill_with_data (handle, data, data_len, error)) {
-            g_object_unref (G_OBJECT (handle));
+        if (!rsvg_handle_fill_with_data (handle, (char *) data, data_len, error)) {
+            g_object_unref (handle);
             handle = NULL;
         }
     }
@@ -75,33 +76,32 @@ rsvg_handle_new_from_data (const guint8 * data, gsize data_len, GError ** error)
  * @file_name: The file name to load. If built with gnome-vfs, can be a URI.
  * @error: return location for errors
  *
- * Loads the SVG specified by #file_name.
+ * Loads the SVG specified by @file_name.
  *
- * Returns: A RsvgHandle or %NULL if an error occurs.
+ * Returns: A #RsvgHandle or %NULL if an error occurs.
  * Since: 2.14
  */
 RsvgHandle *
 rsvg_handle_new_from_file (const gchar * file_name, GError ** error)
 {
     gchar *base_uri;
-    GByteArray *f;
+    char *data;
+    gsize data_len;
     RsvgHandle *handle = NULL;
 
     rsvg_return_val_if_fail (file_name != NULL, NULL, error);
 
     base_uri = rsvg_get_base_uri_from_filename (file_name);
-    f = _rsvg_acquire_xlink_href_resource (file_name, base_uri, error);
+    data = _rsvg_io_acquire_data (file_name, base_uri, NULL, &data_len, NULL, error);
 
-    if (f) {
+    if (data) {
         handle = rsvg_handle_new ();
-        if (handle) {
-            rsvg_handle_set_base_uri (handle, base_uri);
-            if (!rsvg_handle_fill_with_data (handle, f->data, f->len, error)) {
-                g_object_unref (G_OBJECT (handle));
-                handle = NULL;
-            }
+        rsvg_handle_set_base_uri (handle, base_uri);
+        if (!rsvg_handle_fill_with_data (handle, data, data_len, error)) {
+            g_object_unref (handle);
+            handle = NULL;
         }
-        g_byte_array_free (f, TRUE);
+        g_free (data);
     }
 
     g_free (base_uri);
